## g2clib 1.7.0

=== CMakeLists.txt ===
# This is the main CMake file for NCEPLIBS-g2c.
#
# Mark Potts, Kyle Gerheiser
cmake_minimum_required(VERSION 3.15)

# Read the VERSION file.
file(STRINGS "VERSION" pVersion)

project(
  g2c
  VERSION ${pVersion}
  LANGUAGES C)

include(GNUInstallDirs)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/")

# Handle user options.
option(ENABLE_DOCS "Enable generation of doxygen-based documentation." OFF)
option(USE_PNG      "Use PNG library"      ON)
option(USE_Jasper   "Use Jasper library"   ON)
option(USE_OpenJPEG "Use OpenJPEG library" OFF)
option(BUILD_SHARED_LIBS "Build shared libraries" ON)
option(FTP_TEST_FILES "Fetch and test with files on FTP site." OFF)
option(LOGGING "Turn on internal logging messages. Only useful to g2c developers." OFF)

# Set pre-processor symbol if logging is desired.
if(LOGGING)
  add_definitions(-DLOGGING)
endif()

# The user must select either Jasper of OpenJPEG
if(USE_Jasper AND USE_OpenJPEG)
  message(FATAL_ERROR "Either Jasper or OpenJPEG should be used, not both.")
endif()

if(NOT CMAKE_BUILD_TYPE MATCHES "^(Debug|Release|RelWithDebInfo|MinSizeRel)$")
  message(STATUS "Setting build type to 'Release' as none was specified.")
  set(CMAKE_BUILD_TYPE
      "Release"
      CACHE STRING "Choose the type of build." FORCE)
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release"
                                               "MinSizeRel" "RelWithDebInfo")
endif()

# Find required packages to use PNG.
if(USE_PNG)
  find_package(ZLIB REQUIRED)
  find_package(PkgConfig REQUIRED)
  find_package(PNG REQUIRED)
else()
  message(STATUS "Will not build PNG support")
endif()

# Find Jasper if it is desired.
if(USE_Jasper)
  find_package(Jasper 2.0.25 REQUIRED)
else()
  message(STATUS "Will not build Jasper support")
endif()

# Find OpenJpeg if it is desired.
if(USE_OpenJPEG)
  find_package(OpenJPEG REQUIRED)
else()
  message(STATUS "Will not build OpenJPEG support")
endif()

# Set the compiler flags.
if(CMAKE_C_COMPILER_ID MATCHES "^(Intel)$")
  set(CMAKE_C_FLAGS "-g -traceback ${CMAKE_C_FLAGS}")
  set(CMAKE_C_FLAGS_RELEASE "-O3")
  set(CMAKE_C_FLAGS_DEBUG "-O0")
elseif(CMAKE_C_COMPILER_ID MATCHES "^(GNU|Clang|AppleClang)$")
  set(CMAKE_C_FLAGS "-g ${CMAKE_C_FLAGS}")
  set(CMAKE_C_FLAGS_RELEASE "-O3")
  set(CMAKE_C_FLAGS_DEBUG "-O0 -ggdb -Wall")
endif()

set(lib_name ${PROJECT_NAME})

add_library(${lib_name}
    src/grib2_int.h
    src/cmplxpack.c
    src/compack.c
    src/comunpack.c
    src/drstemplates.c
    src/g2_addfield.c
    src/g2_addgrid.c
    src/g2_addlocal.c
    src/g2_create.c
    src/g2_free.c
    src/g2_getfld.c
    src/g2_gribend.c
    src/g2_info.c
    src/g2_miss.c
    src/g2_unpack1.c
    src/g2_unpack2.c
    src/g2_unpack3.c
    src/g2_unpack4.c
    src/g2_unpack5.c
    src/g2_unpack6.c
    src/g2_unpack7.c
    src/gbits.c
    src/getdim.c
    src/getpoly.c
    src/gridtemplates.c
    src/int_power.c
    src/misspack.c
    src/mkieee.c
    src/pack_gp.c
    src/pdstemplates.c
    src/rdieee.c
    src/reduce.c
    src/seekgb.c
    src/simpack.c
    src/simunpack.c
    src/specpack.c
    src/specunpack.c
    src/util.c
)

set_property(TARGET ${lib_name} PROPERTY C_STANDARD 11)

# Build with PNG.
if(PNG_FOUND)
  message(STATUS "Found PNG:")
  message(STATUS "      PNG include directories ${PNG_INCLUDE_DIR}")
  message(STATUS "      PNG libraries ${PNG_LIBRARIES}")
  target_sources(${lib_name} PRIVATE src/dec_png.c
                                     src/enc_png.c
                                     src/pngpack.c
                                     src/pngunpack.c)
  target_compile_definitions(${lib_name} PRIVATE USE_PNG)
  target_link_libraries(${lib_name} PRIVATE ${PNG_LIBRARIES})
  target_include_directories(${lib_name} PRIVATE "${PNG_INCLUDE_DIRS}")
  set(G2_PNG_ENABLED ON)
endif()

# Build with Jasper.
if(JASPER_FOUND)
  message(STATUS "Found JASPER:")
  message(STATUS "      JASPER include directories ${JASPER_INCLUDE_DIR}")
  message(STATUS "      JASPER libraries ${JASPER_LIBRARIES} version ${JASPER_VERSION}")
  target_sources(${lib_name} PRIVATE src/dec_jpeg2000.c
                                     src/enc_jpeg2000.c
                                     src/jpcpack.c
                                     src/jpcunpack.c)
  target_compile_definitions(${lib_name} PRIVATE USE_JPEG2000)
  target_link_libraries(${lib_name} PRIVATE ${JASPER_LIBRARIES})
  target_include_directories(${lib_name} PRIVATE "${JASPER_INCLUDE_DIR}")
  set(G2_JPEG2000_ENABLED ON)
  if(JASPER_VERSION_STRING VERSION_GREATER_EQUAL "3")
    message(STATUS "      JASPER is version 3.0 or greater")    
    add_definitions(-DJASPER3)
  endif()
endif()

# Build with OpenJPEG.
if(OPENJPEG_FOUND)
  message(STATUS "Found OpenJPEG:")
  message(STATUS "      OpenJPEG include directories ${OpenJPEG_INCLUDE_DIRS}")
  message(STATUS "      OpenJPEG libraries ${OpenJPEG_LIBRARIES}")
  target_sources(${lib_name} PRIVATE src/decenc_openjpeg.c
                                     src/jpcpack.c
                                     src/jpcunpack.c)
  target_compile_definitions(${lib_name} PRIVATE USE_OPENJPEG)
  target_link_libraries(${lib_name} PRIVATE ${OpenJPEG_LIBRARIES})
  target_include_directories(${lib_name} PRIVATE "${OpenJPEG_INCLUDE_DIRS}")
  set(G2_JPEG2000_ENABLED ON)
endif()

# Create this header file, which has the contents of the VERSION file
# substituted in.
CONFIGURE_FILE("${CMAKE_CURRENT_SOURCE_DIR}/src/grib2.h.in" "${CMAKE_CURRENT_BINARY_DIR}/src/grib2.h"
  @ONLY)

set_target_properties(${lib_name} PROPERTIES PUBLIC_HEADER "${CMAKE_CURRENT_BINARY_DIR}/src/grib2.h")

target_include_directories(
  ${lib_name}
  PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/src;${CMAKE_CURRENT_SOURCE_DIR}/src>"
         $<INSTALL_INTERFACE:${CMAKE_INSTALL_PREFIX}/include>
)

target_link_libraries(${lib_name} INTERFACE m)

### Install g2c library
install(
  TARGETS ${lib_name}
  EXPORT ${PROJECT_NAME}Exports
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

### Package config
include(CMakePackageConfigHelpers)
set(CONFIG_INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME})

export(EXPORT ${PROJECT_NAME}Exports
  NAMESPACE ${PROJECT_NAME}::
  FILE ${PROJECT_NAME}-targets.cmake)

# g2c-config.cmake
configure_package_config_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/cmake/PackageConfig.cmake.in ${CMAKE_BINARY_DIR}/${PROJECT_NAME}-config.cmake
  INSTALL_DESTINATION ${CONFIG_INSTALL_DESTINATION})
install(FILES ${CMAKE_BINARY_DIR}/${PROJECT_NAME}-config.cmake
  DESTINATION ${CONFIG_INSTALL_DESTINATION})

# g2c-config-version.cmake
write_basic_package_version_file(
  ${CMAKE_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake
  VERSION ${PROJECT_VERSION}
  COMPATIBILITY AnyNewerVersion)
install(FILES ${CMAKE_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake
  DESTINATION ${CONFIG_INSTALL_DESTINATION})

# g2c-targets.cmake and g2c-targets-<build-type>.cmake
install(EXPORT ${PROJECT_NAME}Exports
  NAMESPACE ${PROJECT_NAME}::
  FILE ${PROJECT_NAME}-targets.cmake
  DESTINATION ${CONFIG_INSTALL_DESTINATION})

# Determine whether or not to generate documentation.
if(ENABLE_DOCS)
  find_package(Doxygen REQUIRED)
endif()
add_subdirectory(docs)

# Run unit tests.
include(CTest)
add_subdirectory(tests)

=== tests/CMakeLists.txt ===
# This is the cmake build file for the tests directory of the
# NCEPLIBS-g2c project.
#
# Ed Hartnett, 7/11/21
# Dusan Jovic

# Some test files are large and are kept on the NOAA EMC FTP
# site. This function is used to download such test data. It takes two
# arguments, the URL and the file to be downloaded.
function(PULL_DATA THE_URL THE_FILE)
  if(NOT EXISTS "${CMAKE_CURRENT_BINARY_DIR}/${THE_FILE}")
    file(DOWNLOAD
      ${THE_URL}/${THE_FILE}
      ${CMAKE_CURRENT_BINARY_DIR}/${THE_FILE}
      SHOW_PROGRESS
      STATUS status
      INACTIVITY_TIMEOUT 30
      )
    list(GET status 0 status_num)
    if(NOT status_num EQUAL 0 OR NOT EXISTS "${CMAKE_CURRENT_BINARY_DIR}/${THE_FILE}")
      message(FATAL_ERROR "Could not download ${THE_FILE}")
    endif()
  endif()
endfunction()

# Some very small test files may be committed to the repo. This
# function copies such a data file to the build directory.
FILE(COPY ${CMAKE_CURRENT_SOURCE_DIR}/gdaswave.t00z.wcoast.0p16.f000.grib2
  DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/)
FILE(COPY ${CMAKE_CURRENT_SOURCE_DIR}/gdaswave.t00z.wcoast.0p16.f000.grib2.idx
  DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/)

# Run each test.
function(g2c_test name)
  add_executable(${name} ${name}.c)
  add_dependencies(${name} g2c)
  target_link_libraries(${name} PRIVATE g2c)
  add_test(NAME ${name} COMMAND ${name})
endfunction()

# Does the user want to get extra test files from the FTP site, and
# run extra tests on them?
if(FTP_TEST_FILES)
  # Get the files from the FTP site.
  set(G2_FTP_URL "https://ftp.emc.ncep.noaa.gov/static_files/public/NCEPLIBS-g2")
  set(WW3_WEST_FILE "WW3_Regional_US_West_Coast_20220718_0000.grib2")
  set(WW3_EAST_FILE "WW3_Regional_US_East_Coast_20220717_0600.grib2")
  # Not using the East Coast file yet.
  # foreach(THE_FILE IN LISTS WW3_WEST_FILE WW3_EAST_FILE) 
  foreach(THE_FILE IN LISTS WW3_WEST_FILE) 
    PULL_DATA(${G2_FTP_URL} ${THE_FILE})
  endforeach()

  # Add tests that use the data downloaded from FTP.
endif()

# Always run these tests.
g2c_test(tst_g2_create)
g2c_test(tst_g2_addgrid)
g2c_test(tst_g2_addfield)
g2c_test(tst_decode)
g2c_test(tst_gbits)
g2c_test(tst_gridtemplates)
g2c_test(tst_pdstemplates)
g2c_test(tst_drstemplates)
g2c_test(tst_unpack)
g2c_test(tst_getdim)
g2c_test(tst_simpack)
g2c_test(tst_addfield_spec)
g2c_test(tst_spec)
g2c_test(tst_com)
g2c_test(tst_g2_addlocal)
g2c_test(tst_seekgb)

# Run these tests only if libpng is linked.
if(USE_PNG)
  g2c_test(tst_png)
  g2c_test(tst_addfield2)
endif()

# Run these tests only if Jasper or OpenJPEG are linked.
if(USE_Jasper OR USE_OpenJPEG)
  g2c_test(tst_jpeg)
  g2c_test(tst_addfield3)
  g2c_test(tst_addfield4)
endif()

## g2clib 1.2.2

=== debian/changelog ===
g2clib (1.2.2-2) unstable; urgency=low

  * Fix to build with libpng15. Closes: #650486.
  * Now require pkg-config to build, as we use it to detect the appropriate
    png library at build-time.
  * Make Multi-Arch. 
  * Add DEP-3 headers to all patches.

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 30 Nov 2011 12:32:27 +0000

g2clib (1.2.2-1) unstable; urgency=low

  * New upstream release.
  * Move to source format 3, dh rules.
  * Standards-Version: 3.9.2.

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 13 Apr 2011 12:23:55 +0100

g2clib (1.1.9-1) unstable; urgency=low

  * New upstream release. Closes: #547282.
  * Standards-Version: 3.8.3. 

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 20 Oct 2009 14:34:30 +0100

g2clib (1.1.8-1) unstable; urgency=low

  * Initial release. (Closes: #531959).
  * Debian/copyright contains statement on public-domain nature of code.

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 24 Jul 2009 19:56:18 +0100

=== debian/control ===
Source: g2clib
Section: utils
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper  (>= 7.0.50~), gfortran, libjasper-dev, libpng-dev, zlib1g-dev, pkg-config
Standards-Version: 3.9.2
Homepage: http://www.nco.ncep.noaa.gov/pmb/codes/GRIB2/

Package: libgrib2c0d
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: NCEP GRIB2 encoder/decoder library
 This is the libgrib2c library from NCEP for encoding and decoding 'GRIB2'
 data formats. 

Package: libgrib2c-dev
Section: libdevel
Architecture: any
Depends: libgrib2c0d ( = ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Recommends: pkg-config
Description: NCEP GRIB2 library - development files
 This is the libgrib2c library from NCEP for encoding and
 decoding 'GRIB2' data formats.
 .
 This package contains the static libraries and headers needed to build 
 applications against libgrib2.

=== debian/rules ===
#!/usr/bin/make -f

# magic debhelper rule
%:
	dh $@

DESTDIR:=`pwd`/debian/tmp/
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)


#export DH_VERBOSE=1

override_dh_auto_install:
	$(MAKE) prefix=$(DESTDIR)/usr LIBDIR=$(DESTDIR)/$(LIBDIR)  install
	dh_link -p libgrib2c-dev $(LIBDIR)/libgrib2c.so.0d        $(LIBDIR)/libgrib2c.so

## g2clib 1.4.0

=== debian/changelog ===
g2clib (1.4.0-2) unstable; urgency=medium

  * Standards-Version: 3.9.5
  * Add prototypes for g2_unpack*() used in python-grib, to grib.h
    to fix implicit declarations 

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 19 Dec 2013 23:28:24 +0000

g2clib (1.4.0-1) unstable; urgency=low

  * New upstream.
  * Add watch file.
  * Now at Standards-Version: 3.9.4 
  * Add flags to harden library.
  * Ensure it can build twice-in-a-row: clean binaries in rules
  * Ensure static lib is shipped in -dev file. Closes: #701547

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 28 May 2013 19:45:05 +0100

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: utils
 Priority: optional
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
-Build-Depends: debhelper  (>= 7.0.50~), gfortran, libjasper-dev, libpng-dev, zlib1g-dev, pkg-config
-Standards-Version: 3.9.2
+Build-Depends: debhelper  (>= 9), gfortran, libjasper-dev, libpng-dev, zlib1g-dev, pkg-config
+Standards-Version: 3.9.5
 Homepage: http://www.nco.ncep.noaa.gov/pmb/codes/GRIB2/
 
 Package: libgrib2c0d

=== debian/rules ===
--- 
+++ 
@@ -11,6 +11,10 @@
 
 #export DH_VERBOSE=1
 
+override_dh_auto_clean:
+	rm -f *.o *.a libgrib2c.so.0d *.pc
+	dh_clean
+
 override_dh_auto_install:
 	$(MAKE) prefix=$(DESTDIR)/usr LIBDIR=$(DESTDIR)/$(LIBDIR)  install
 	dh_link -p libgrib2c-dev $(LIBDIR)/libgrib2c.so.0d        $(LIBDIR)/libgrib2c.so

=== debian/watch ===
version=3
http://www.nco.ncep.noaa.gov/pmb/codes/GRIB2/g2clib-(.+)\.tar

## g2clib 1.6.0

=== debian/changelog ===
g2clib (1.6.0-9build1) cosmic; urgency=medium

  * No-change rebuild for libgfortran soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 17 Jul 2018 12:20:15 +0000

g2clib (1.6.0-9) unstable; urgency=medium

  * Rename openjpeg-2.2 to openjpeg-2.3. Closes: #878813
  * Standdards-Version: 4.1.1

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 17 Oct 2017 08:57:29 +0100

g2clib (1.6.0-8) unstable; urgency=medium

  * /usr/include/openjpeg-2.1 renamed openjpeg-2.2. Change include
    Closes: 876806.
  * Standards-Version: 4.1.0

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 27 Sep 2017 06:37:55 +0100

g2clib (1.6.0-7) unstable; urgency=medium

  * Fix invalid dir in grib2c.pc. Closes: #860277.
    Thanks to Chris Lamb
  * Change Libs.private: link against libopenjp2 not libjasper

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 17 Apr 2017 18:00:14 +0100

g2clib (1.6.0-6) unstable; urgency=medium

  * Don't build in parallel. Closes: #848732

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 23 Dec 2016 10:04:51 +0000

g2clib (1.6.0-5) unstable; urgency=medium

  * Now use openjpeg2 for compression/decompression.
  * Use debhelper 10.
  * Patch for 64-bit int (segfaults on SEVIRI files) Closes: #823226

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 18 Dec 2016 18:42:19 +0000

g2clib (1.6.0-4) unstable; urgency=medium

  * Remove jp*pack as JPEG2000 not supported without jasper/openjpeg

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 11 Jun 2016 08:14:45 +0100

g2clib (1.6.0-3) unstable; urgency=medium

  * Standards-Version: 3.9.8. No changes required
  * Remove libjasper from g2clib. 

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 24 May 2016 08:19:00 +0100

g2clib (1.6.0-2) unstable; urgency=medium

  * Ship other headers *templates.h in libgrib2c-dev package
  * Drop -m64 which breaks most architecture builds 

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 08 Mar 2016 10:18:12 +0000

g2clib (1.6.0-1) unstable; urgency=medium

  * New upstream release.
  * Standards-Version: 3.9.7 compliant

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 20 Feb 2016 14:16:59 +0000

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,9 @@
 Section: utils
 Priority: optional
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
-Build-Depends: debhelper  (>= 9), gfortran, libjasper-dev, libpng-dev, zlib1g-dev, pkg-config
-Standards-Version: 3.9.5
+Build-Depends: debhelper  (>= 10), gfortran, libpng-dev, zlib1g-dev, pkg-config,
+ libopenjp2-7-dev 
+Standards-Version: 4.1.1
 Homepage: http://www.nco.ncep.noaa.gov/pmb/codes/GRIB2/
 
 Package: libgrib2c0d

=== debian/rules ===
#!/usr/bin/make -f

DEB_BUILD_OPTIONS=parallel=1

# magic debhelper rule
%:
	dh $@ --no-parallel

DESTDIR:=$(CURDIR)/debian/tmp/
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)


#export DH_VERBOSE=1

override_dh_auto_clean:
	rm -f *.o *.a libgrib2c.so.0d *.pc
	dh_clean

override_dh_auto_install:
	$(MAKE) prefix=$(DESTDIR)/usr LIBDIR=$(DESTDIR)/$(LIBDIR)  install
	sed -i -e 's@libdir=$(DESTDIR)/@libdir=@g' $(DESTDIR)/$(LIBDIR)/pkgconfig/grib2c.pc  # Strip build path
	mv $(DESTDIR)/$(LIBDIR)/./libg2c_v1.6.0.a $(DESTDIR)/$(LIBDIR)/libgrib2c.a
	dh_link -p libgrib2c-dev $(LIBDIR)/libgrib2c.so.0d        $(LIBDIR)/libgrib2c.so

## g2clib 1.6.2

=== debian/changelog ===
g2clib (1.6.2-2) unstable; urgency=medium

  * Regression: drop -m64 as breaks most archs

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 21 Dec 2020 16:28:45 +0000

g2clib (1.6.2-1) unstable; urgency=medium

  * New upstream release
  * Drop DEB_BUILD_OPTIONS from debian/rules
  * Standards-Version: 4.5.1
  * Now use debhelper-compat (= 13)
  * Drop Pre-Depends, no longer needed
  * Use pkgconfig rather than hardcoded include path
  * Drop depends on gfortran. not used.
  * Move to https for Homepage
  * Add references to salsa page to d/control
  * Add d/gbb.conf to point to DEP-14 branches
  * Drop hard-coded 'xz' compression

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 20 Dec 2020 12:38:08 +0000

=== debian/control ===
--- 
+++ 
@@ -2,16 +2,20 @@
 Section: utils
 Priority: optional
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
-Build-Depends: debhelper  (>= 10), gfortran, libpng-dev, zlib1g-dev, pkg-config,
+Build-Depends: debhelper-compat  (= 13), 
+ libpng-dev, 
+ zlib1g-dev, 
+ pkg-config,
  libopenjp2-7-dev 
-Standards-Version: 4.1.1
-Homepage: http://www.nco.ncep.noaa.gov/pmb/codes/GRIB2/
+Standards-Version: 4.5.1
+Homepage: https://www.nco.ncep.noaa.gov/pmb/codes/GRIB2/
+Vcs-Browser: https://salsa.debian.org:/science-team/g2clib.git
+Vcs-Git: https://salsa.debian.org:/science-team/g2clib.git -b debian/latest
 
 Package: libgrib2c0d
 Section: libs
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
-Pre-Depends: ${misc:Pre-Depends}
 Multi-Arch: same
 Description: NCEP GRIB2 encoder/decoder library
  This is the libgrib2c library from NCEP for encoding and decoding 'GRIB2'

## g2clib 1.6.3

=== debian/changelog ===
g2clib (1.6.3-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 10 Mar 2021 12:46:40 +0000

=== debian/rules ===
#!/usr/bin/make -f

# magic debhelper rule
%:
	dh $@ --no-parallel

DESTDIR:=$(CURDIR)/debian/tmp/
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)

#export DH_VERBOSE=1

override_dh_auto_clean:
	rm -f *.o *.a libgrib2c.so.0d *.pc
	dh_clean

override_dh_auto_install:
	$(MAKE) prefix=$(DESTDIR)/usr LIBDIR=$(DESTDIR)/$(LIBDIR)  install
	sed -i -e 's@libdir=$(DESTDIR)/@libdir=@g' $(DESTDIR)/$(LIBDIR)/pkgconfig/grib2c.pc  # Strip build path
	mv $(DESTDIR)/$(LIBDIR)/./libg2c_v1.6.*.a $(DESTDIR)/$(LIBDIR)/libgrib2c.a
	dh_link -p libgrib2c-dev $(LIBDIR)/libgrib2c.so.0d        $(LIBDIR)/libgrib2c.so

## g2clib 1.6.4

=== debian/changelog ===
g2clib (1.6.4-3) unstable; urgency=medium

  * Drop real.3 manpage; redundant alias conflicts with other pages.
    Closes: #1011424
  * Standards-Version: 4.6.1

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 03 Jun 2022 09:12:08 +0100

g2clib (1.6.4-2) unstable; urgency=medium

  * Add Breaks/Replaces libgrib2c-dev to libg2c-dev

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 11 May 2022 12:07:53 +0100

g2clib (1.6.4-1) experimental; urgency=medium

  * New upstream release
  * Library renamed to g2c upstream
    - Renamed binary packages to libg2c{0d,-dev}
    - Added symlink libgrib2c.so -> libg2c.so for transition
  * Home page moved to https://github.com/NOAA-EMC/NCEPLIBS-g2c
  * Standards-Version: 4.6.0
  * Update watch file to github
  * Move to cmake-based build system,

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 03 May 2022 12:15:51 +0100

=== debian/control ===
--- 
+++ 
@@ -3,16 +3,18 @@
 Priority: optional
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
 Build-Depends: debhelper-compat  (= 13), 
+ cmake,
  libpng-dev, 
  zlib1g-dev, 
  pkg-config,
+ doxygen,
  libopenjp2-7-dev 
-Standards-Version: 4.5.1
-Homepage: https://www.nco.ncep.noaa.gov/pmb/codes/GRIB2/
+Standards-Version: 4.6.1
+Homepage: https://github.com/NOAA-EMC/NCEPLIBS-g2c
 Vcs-Browser: https://salsa.debian.org:/science-team/g2clib.git
 Vcs-Git: https://salsa.debian.org:/science-team/g2clib.git -b debian/latest
 
-Package: libgrib2c0d
+Package: libg2c0d
 Section: libs
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
@@ -21,10 +23,12 @@
  This is the libgrib2c library from NCEP for encoding and decoding 'GRIB2'
  data formats. 
 
-Package: libgrib2c-dev
+Package: libg2c-dev
 Section: libdevel
 Architecture: any
-Depends: libgrib2c0d ( = ${binary:Version}), ${misc:Depends}
+Depends: libg2c0d ( = ${binary:Version}), ${misc:Depends}
+Breaks: libgrib2c-dev
+Replaces: libgrib2d-dev
 Multi-Arch: same
 Recommends: pkg-config
 Description: NCEP GRIB2 library - development files

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

# magic debhelper rule
%:
	dh $@ --buildsystem=cmake --builddirectory=debian/build

DESTDIR:=$(CURDIR)/debian/tmp/
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)

export DH_VERBOSE=1

override_dh_auto_configure:
	dh_auto_configure  -- \
		-DUSE_Jasper=OFF \
		-DUSE_OpenJPEG=On \
		-DENABLE_DOCS=On


override_dh_auto_install:
	dh_auto_install
	mv $(DESTDIR)/$(LIBDIR)/libg2c_static.a $(DESTDIR)/$(LIBDIR)/libg2c.a
	# Transitional temporary link
	dh_link -p libg2c-dev $(LIBDIR)/libg2c.so           $(LIBDIR)/libgrib2c.so
	# See #1011424
	rm -f ./debian/build/docs/man/man3/real.3

## g2clib 1.7.0

=== debian/changelog ===
g2clib (1.7.0-3) unstable; urgency=medium

  * Typo: Replaces: libgrib2c-dev not libgrib2d-dev. Closes: #1034962

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 27 Apr 2023 16:30:55 +0100

g2clib (1.7.0-2) unstable; urgency=medium

  * Fix for FTBFS on i386 thanks to Adrian  Bunk. Closes: #1022262

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 23 Nov 2022 11:40:59 +0000

g2clib (1.7.0-1) unstable; urgency=medium

  * New upstream release
  * Build without docs for now; crashes making docs

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 23 Aug 2022 13:30:22 +0100

=== debian/control ===
--- 
+++ 
@@ -28,7 +28,7 @@
 Architecture: any
 Depends: libg2c0d ( = ${binary:Version}), ${misc:Depends}
 Breaks: libgrib2c-dev
-Replaces: libgrib2d-dev
+Replaces: libgrib2c-dev
 Multi-Arch: same
 Recommends: pkg-config
 Description: NCEP GRIB2 library - development files

=== debian/rules ===
--- 
+++ 
@@ -6,17 +6,24 @@
 %:
 	dh $@ --buildsystem=cmake --builddirectory=debian/build
 
+ifeq ($(DEB_HOST_ARCH_CPU),i386)
+  export DEB_CFLAGS_MAINT_APPEND = -ffloat-store
+endif
+
 DESTDIR:=$(CURDIR)/debian/tmp/
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
+CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) -I $(CURDIR)/debian/build/src 
+
 
 export DH_VERBOSE=1
 
 override_dh_auto_configure:
 	dh_auto_configure  -- \
+		-DCMAKE_C_CFLAGS="${CFLAGS}" \
 		-DUSE_Jasper=OFF \
 		-DUSE_OpenJPEG=On \
-		-DENABLE_DOCS=On
+		-DENABLE_DOCS=Off
 
 
 override_dh_auto_install:

=== debian/watch ===
version=3
opts="uversionmangle=s/-rc/~rc/, filenamemangle=s/.+\/(\d\S+)\.tar\.gz/$1\.tar\.gz/" \
  https://github.com/NOAA-EMC/NCEPLIBS-g2c/tags .*/v?(\d\d?\d?\..+).tar\.gz
